# coding

coding 提供两个开发环境：

* 云原生开发环境
* cloudstudio

前者免费 160 小时/月，后者免费 3000分钟 = 50小时/月。


## 远程开发

在本地通过 repo_sync tools v1.12，快速创建项目，项目推到云端，然后在云端开发。

添加 `.coding-ci.yml` 以及 `.ide/Dockerfile`配置文件，

```
$:
  api_trigger_vscode:
    clouddev:
      runner:
        cpus: 4
      docker:
        cpus: 4
        build: .ide/Dockerfile
        image: codingci/default-env:latest
      services:
        - vscode
        - docker
      stages:
        - name: 开启云原生远程开发
          type: vscode:go

```

节省cpu，这里node开发，php开发等配置cpu第，app开发等配置cpu高。


## cloudstudio

cloudstudio 是独立的产品，一般都是基于模板快速新建开发环境，当然也可以手动选择项目新建环境。只能选择系统开发环境。主要用户数据分析。


## ci/cd

coding 提供 ci/cd 服务，可以在项目中配置 ci/cd，自动化构建，测试，部署。








